#include "VerifLLMeasurer.h"
#include "string_utils.h"

namespace Torch {

VerifLLMeasurer::VerifLLMeasurer(Sequence *inputs_, DataSet *data_, char** file_names_, XFile *file_) : Measurer(data_, file_)
{
  inputs = inputs_;
	file_names = (char**)allocator->alloc(data->n_examples*sizeof(char*));
	for(int i=0;i<data->n_examples;i++){
		char* temp = strBaseName(file_names_[i]);
		file_names[i] = strRemoveSuffix(temp);
		allocator->retain(file_names[i]);
	}
  addBOption("average frames", &average_frames, true, "divided by the number of frames");
}

void VerifLLMeasurer::measureExample()
{
  real sum = .0;
  for(int i = 0; i < inputs->n_frames; i++)
		sum += inputs->frames[i][0];
  if(average_frames)
     sum /= inputs->n_frames;

  if(binary_mode){
		int size = strlen(file_names[data->real_current_example_index]);
    file->write(file_names[data->real_current_example_index], size, 1);\
    file->write(&sum, sizeof(real), 1);\
		}
  else
  {
    file->printf("%s %g\n", file_names[data->real_current_example_index],sum);
    //file->printf("%s %g ", file_names[data->real_current_example_index],sum);
    //for(int i = 0; i < inputs->n_frames; i++)
    //     file->printf("| %g",inputs->frames[i][0]);
    //file->printf("\n");
  }
}


VerifLLMeasurer::~VerifLLMeasurer()
{

}
}

