#ifndef VERIF_LL_MEASURER_INC
#define VERIF_LL_MEASURER_INC

#include "Measurer.h"
#include "DataSet.h"

namespace Torch {

/** This class measures the negative log likelihood. In fact, it supposes
    that the input given is the positive log likelihood. It can 
    then normalized by the total number of frames and/or the number of total
		of examples.

    @author Johnny Mariethoz (Johnny.Mariethoz@idiap.ch)
*/
class VerifLLMeasurer : public Measurer
{
  public:
    bool average_frames;
		char** file_names;
    real internal_error;
    /// contains a pointer to the negative log likelihood to measure
    Sequence *inputs;
    ///
    VerifLLMeasurer(Sequence *inputs_, DataSet* data_, char** file_names_, XFile *file_);

    virtual void measureExample();

    virtual ~VerifLLMeasurer();
};


}

#endif
