#include "ipFlip.h"

namespace Torch {

ipFlip::ipFlip(int width_, int height_, const char *coding_) : ipCore(coding_)
{
	width = width_;
        height = height_;

	seq_out = new(allocator) Sequence(1, width*height*n_planes);
}

void ipFlip::process(Sequence *seq_in)
{
	switch(coding_id)
	{
	case 0:
	       	for(int h = 0; h < height; h++)
        		for(int w = 0; w < width; w++)
				seq_out->frames[0][w + (height - h - 1) * width] = seq_in->frames[0][w + h * width];
	
		break;
	case 1:
	case 2:
	       	for(int h = 0; h < height; h++)
        		for(int w = 0; w < width; w++)
			{
			   	int base_in = w + h * width;
				int base_out = w + (height - h - 1) * width;

				base_in *= 3;
				base_out *= 3;

				seq_out->frames[0][base_out] = seq_in->frames[0][base_in];
				seq_out->frames[0][base_out+1] = seq_in->frames[0][base_in+1];
				seq_out->frames[0][base_out+2] = seq_in->frames[0][base_in+2];
			}
		break;
	case 3: 
		message("ipFlip() not implemented for float format");
		break;
	}
}

ipFlip::~ipFlip()
{
}

}

