#include "ipMirror.h"

namespace Torch {

ipMirror::ipMirror(int width_, int height_, const char *coding_) : ipCore(coding_)
{
	width = width_;
	height = height_;

	seq_out = new(allocator) Sequence(1, width_*height_*n_planes);
}

void ipMirror::process(Sequence *seq_in)
{
   	int i, m;
	
	switch(coding_id)
	{
	case 0:
		for(int h = 0; h < height; h++)
		{
			for(int w = 0; w < width; w++)
			{
				i = h * width + w;
				m = h * width + (width - w - 1);
			   
				seq_out->frames[0][m] = seq_in->frames[0][i];
			}
		}
		break;
	case 1:
	case 2:
		for(int h = 0; h < height; h++)
		{
			for(int w = 0; w < width; w++)
			{
				i = h * width + w;
				m = h * width + (width - w - 1);
			   
				seq_out->frames[0][3*m] = seq_in->frames[0][3*i];
				seq_out->frames[0][3*m+1] = seq_in->frames[0][3*i+1];
				seq_out->frames[0][3*m+2] = seq_in->frames[0][3*i+2];
			}
		}
		break;
	case 3:
		message("ipMirror::process() not implemented for float format");
		break;
	}
}

ipMirror::~ipMirror()
{
}

}

