#ifndef STR_UTILS_INC
#define STR_UTILS_INC

#include "general.h"

namespace Torch {

/** @name Usefull string alloc/free functions

    @author Sebastien Marcel (marcel@idiap.ch)
    @version 2.0
    \Date
    @since 2.0
*/
//@{
/// allocate a string of a given size
char *strAlloc(int size);

/// allocate a string from the size of another string and more
char *strAlloc(const char *str_, int extra = 0);

/// allocate a string from the size of another string, copy it and concat another one
char *strAlloc(const char *str_, char *concat_);

/// free a string from a given size
void strFree(char *str);

/// return the basename of a filename (remove the extension)
void strBasename(char *basename, const char *filename);
//@}

}

#endif
