#ifndef PATTERN_COLLECTOR_INC
#define PATTERN_COLLECTOR_INC

#include "Pattern.h"

namespace Torch {

/** This class is designed to collect patterns unless if #max_patterns# is zero
    
    @author Sebastien Marcel (marcel@idiap.ch)
    @version 2.0
    \Date
    @since 1.0

    @see Pattern
*/
class PatternCollector : public Object
{
public:
	/// pattern width
	int width;

	/// pattern height
	int height;
	
	/// maximum number of patterns
	int max_patterns;

	/// number of patterns collected
	int n_patterns;

	/// patterns collected
	Pattern **patterns;

	//---
	
	///
	PatternCollector(int width_, int height_, int max_patterns_ = 10000);

	///
	void reset() { n_patterns = 0; };
	
	///
	bool add(int x_, int y_, int w_, int h_, real confidence_, int view_ = 0);
	
	///
	~PatternCollector();
};

}

#endif
