#include "HistoEqualSmoothImagePreProcessing.h"

namespace Torch {

HistoEqualSmoothImagePreProcessing::HistoEqualSmoothImagePreProcessing(int width_, int height_)
{
   	width = width_;
	height = height_;

	n_inputs = width * height;
	
	enhancing = new(allocator) ipHistoEqual(width, height, "float");
	smoothing = new(allocator) ipSmoothGaussian3(width, height, "gray", 0.25);
}

void HistoEqualSmoothImagePreProcessing::preProcessInputs(Sequence *inputs)
{
	if(inputs->frame_size != n_inputs)
		error("HistoEqualSmoothImagePreProcessing: sequence->frame_size != (width * height)");

	enhancing->process(inputs);
	smoothing->process(enhancing->seq_out);
	
	real *output_ = smoothing->seq_out->frames[0];
	   
	for(int i = 0 ; i < n_inputs ; i++) inputs->frames[0][i] = output_[i];
}

void HistoEqualSmoothImagePreProcessing::preProcessTargets(Sequence *targets)
{
}

HistoEqualSmoothImagePreProcessing::~HistoEqualSmoothImagePreProcessing()
{
}

}

