#ifndef SHAPE_GT_MEASURER_INC
#define SHAPE_GT_MEASURER_INC

#include "Object.h"
#include "vision.h"

namespace Torch {

/** This class is designed to be a Ground Truth measurer for 2D shapes (array of 2D points)

    @author Sebastien Marcel (marcel@idiap.ch)
    \Date
    @version 2.0
    @since 1.0
*/
class ShapeGTMeasurer : public Object
{
public:
	/// verbose
	bool verbose;

	//-----
	
	///
	ShapeGTMeasurer();

	/// given a set of points, compute some measure and return a binary decision.
	virtual bool measure(int n_points_, sPoint2D *shape_, real *the_measure = NULL) = 0;

	///
	virtual ~ShapeGTMeasurer();
};

}

#endif

